'use strict';

angular.module('adf.widget.electre.lavoisier')
    .directive('textDisplay',
        [
            'lavoisierHttpRequestService', 'domService',
            function (lavoisierHttpRequestService, domService) {
                function htmlEntities(str) {
                    return String(str).replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;');
                }
                
                return {
                    scope : {
                        control : '='
                    },
                    link : function (scope, element, attrs) {
                        scope.control.controller.processing();
                        
                        lavoisierHttpRequestService.getResult_2(scope.control.config)
                        .then(
                            function (value) {
                                scope.value = htmlEntities(value);
                                scope.control.controller.setValue(value);

                                var textarea = domService.json2dom({
                                    "textarea" : {
                                        attributes: {
                                            "readonly" : true,
                                            style: {
                                                "font-size": scope.control.fontSize + "px",
                                                "width":"100%",
                                                "resize":"both"
                                            }
                                        }
                                    }
                                });

                                textarea.innerHTML = scope.value;
                                element.prepend(textarea);
                            },
                            function () {
                                var txt = "An error has occurred during the request. Please verify you have entered valid info.";
                                var p = domService.createElement("p").setAttribute('class', "alert alert-warning").getDom();
                                p.innerHTML = txt;
                                element.append(p);

                                throw txt;
                            }
                        ).then(
                            function () {
                                scope.control.controller.success();
                            }, function () {
                                scope.control.controller.failed();
                            }
                        );
                    }
                };
            }
        ]
    ).directive('copyToClipboard',
        [
            function () {
               return {
                   link : function (scope, element, attrs) {
                       new Clipboard(element[0], {
                           target : function () {
                               return element[0].previousElementSibling;
                           }
                       });
                   }
               };
            }
        ]
    );